﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head><title>Updating Analytics Version 2 Controls</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Updating Analytics Version 2 Controls</h1>
        <p>You can update the analytics configurations to fetch a new report. </p>
        <p>The following may be some of the use cases:</p>
        <ul>
            <li>
                <p>Change the analytics query.</p>
            </li>
            <li>
                <p>Change the number of history versions to be stored for the report.</p>
            </li>
            <li>
                <p>Rename the report.</p>
            </li>
            <li>
                <p>Add an allowed action.</p>
            </li>
            <li>
                <p>Add or remove the email template.</p>
            </li>
        </ul>
        <p>You can also delete an an analytics control and also copy a similar analytics control.</p>
        <p><strong>Perform the following steps to edit an analytics control:</strong>
        </p>
        <ol>
            <li>
                <p>Login to IGA, select <strong>Analytics &gt; Analytics Configuration List</strong>.</p>
            </li>
            <li>
                <p>Select the query that you created.</p>
            </li>
            <li>
                <p>In the <strong>Analytics Configuration Details</strong> page that displays, click <strong>Edit</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Edit Analytics Configuration</strong> page that displays, change the configurations.</p>
            </li>
            <li>
                <p>Click <strong>Update</strong>.</p>
            </li>
            <li>
                <p>[Optional] Go to the <strong>Analytics Configuration Details</strong> page and click <strong>Delete</strong>.<br />The analytics control is deleted from IGA.</p>
            </li>
            <li>
                <p>[Optional] Go to the <strong>Analytics Configuration Details</strong> page and click <strong>Create Similar Analytics</strong>.<br />A copy of an existing analytics control is created.</p>
            </li>
        </ol>
        <h2 id="UpdatingAnalyticsVersion2Controls-Limitations">Limitations </h2>
        <p>This section lists some limitations while updating SQL Query of Elasticsearch based controls.</p>
        <p>When the analytics query is modified to replace existing columns ensure that data type is not changed.<br />For example, <br />If you use this query in the first attempt:<br /><span class="attr">select u.username, u.manager from users u</span><br />Here, <code>manager</code> is an INTEGER field in the users table, so Elasticsearch stores the <code>manager</code> column as an INTEGER.<br /><br />If you modify the query as follows:<br /><span class="attr">select u.username , u.owner as 'manager' from users u</span><br />Here, <code>manager</code> is taken from the <code>owner</code> column from the users table and the <code>owner</code> column is a TEXT (varchar) field, so Elasticsearch stores this as TEXT but the same column name is already saved as an INTEGER in the Elasticsearch index.<br /><br />Hence, if the data type for the same column name is changed, you will see an exception and no data will be returned when you run the control. So, you must ensure that you are not using the same column name (or alias name) to store different data types when you modify the query.</p>
    </body>
</html>